<template>
	<f7-page name="productform" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">Iklan Baris</f7-nav-title>
            <f7-nav-title-large>{{ formType }} Iklan</f7-nav-title-large>
		</f7-navbar>
        <f7-block style="text-align: justify;padding:20px;border-radius:7px;" class=" gradient-cyan">
            <h3 class="no-margin">Penting!</h3>
            <p>Informasi toko wajib diisi agar iklan bisa muncul di halaman iklan baris.</p>
        </f7-block>
        <f7-block>
            <div class="uploader margin-medium-bottom">
                <div v-if="product && product.medias.length > 0">
                    <div :id="`image-${media.id}`" class="uploader-item image-item" v-for="media in product.medias" v-bind:key="media.id">
                        <a href="#" @click="handleMediaDelete($event, media.id)"  :style="`background-image: url(${media.url.medium})`"></a>
                    </div>
                    <div class="uploader-item">
                        <a class="text-align-center add-image" href="#" @click="handleUpload">
                            <f7-icon f7="add" size="50"></f7-icon>
                            <span class="display-block">Foto</span>
                        </a>
                    </div>
                </div>
                <div v-else-if="medias.length > 0">
                    <div :id="`image-${media.id}`" class="uploader-item image-item" v-for="media in medias" v-bind:key="media.id">
                        <a href="#" @click="handleMediaDelete($event, media.id)"  :style="`background-image: url(${media.url.original})`"></a>
                    </div>
                    <div class="uploader-item">
                        <a class="text-align-center add-image" href="#" @click="handleUpload">
                            <f7-icon f7="add" size="50"></f7-icon>
                            <span class="display-block">Foto</span>
                        </a>
                    </div>
                </div>
                <div v-else class="uploader-item">
                    <a class="text-align-center add-image" href="#" @click="handleUpload">
                        <f7-icon f7="add" size="50"></f7-icon>
                        <span class="display-block">Foto</span>
                    </a>
                </div>
            </div>
        </f7-block>  
        <f7-list no-hairlines inline-labels class="no-margin">
            <li class="item-content item-input">
                <div class="item-inner">
                    <div class="item-title item-label">Kondisi</div>
                    <div class="item-input-wrap">
                        <p class="no-margin text-align-right">
                            <f7-radio 
                                name="condition" 
                                value="new" 
                                :checked="productForm.condition === 'new'"
                                @change="productForm.condition = $event.target.value"></f7-radio> Baru
                            <f7-radio 
                                name="condition" 
                                value="used"
                                :checked="productForm.condition === 'used'"
                                @change="productForm.condition = $event.target.value"></f7-radio> Bekas
                        </p>
                    </div>
                </div>
            </li>
            <f7-list-item title="Kategori" smart-select :smart-select-params="{'closeOnSelect': true, searchbar: true, searchbarPlaceholder: 'Pilih Kategori'}">
                <select 
                    ref="category" 
                    name="category" 
                    :value="productForm.category"
                    @change="productForm.category = $event.target.value">
                    <optgroup :label="item.name" v-for="item in marketplaceCategories" v-bind:key="item.id">
                        <option
                        v-for="child in item.childs"
                        :value="child.id"
                        v-bind:key="child.id">{{ child.name }}</option>
                    </optgroup>							
                </select>
            </f7-list-item> 
        </f7-list>              
        <f7-list no-hairlines class="no-margin border-separator-top">
            <f7-list-input
                ref="title"
                label="Judul barang / jasa"
                placeholder="Ketik judul barang / jasa"
                maxlength="255"
                clear-button
                :value="productForm.title"
                @input="productForm.title = $event.target.value">
            </f7-list-input>
            <f7-list-input
                ref="description"
                type="textarea"
                label="Deskripsi"
                placeholder="Ketik deskripsi barang"
                resizable					
                :value="productForm.description"
                @input="productForm.description = $event.target.value">
            </f7-list-input>
		</f7-list>
        <f7-list no-hairlines inline-labels class="no-margin border-separator-top">
            <f7-list-input
                class="align-right"
                label="Harga"
                type="number"
                placeholder="Rp 0"
                :value="productForm.price"
                @input="productForm.price = $event.target.value"
            ></f7-list-input>
            <f7-list-item title="Satuan" smart-select :smart-select-params="{'closeOnSelect': true, searchbar: true, searchbarPlaceholder: 'Pilih Satuan'}">
                <select 
                    ref="unit" 
                    name="unit" 
                    :value="productForm.unit"
                    @change="productForm.unit = $event.target.value">
                    <option
                        v-for="item in units"
                        :value="item.id"
                        v-bind:key="item.id">{{ item.name }} ({{ item.symbol }})</option>							
                </select>
            </f7-list-item>
            <f7-list-input
                class="align-right"
                label="Minimum Order"
                type="number"
                placeholder="1"
                :value="productForm.minorder"
                @input="productForm.minorder = $event.target.value"
            ></f7-list-input>            
            <f7-list-input
                class="align-right"
                label="Diskon"
                type="number"
                placeholder="0"
                :value="productForm.discount"
                @input="productForm.discount = $event.target.value"
            ></f7-list-input>
            <f7-list-item>
                <div class="item-title">Bisa Nego?</div>
                <f7-toggle 
                    ref="isnegotiable"
                    name="isnegotiable"
                    color="blue"
                    value="1"
                    :checked="productForm.isnegotiable"
                    @toggleChange="productForm.isnegotiable = $event"></f7-toggle>
            </f7-list-item>
            <f7-list-item>
                <div class="item-title">Bisa Diantar?</div>
                <f7-toggle 
                    ref="isdeliverable"
                    name="isdeliverable"
                    color="blue"
                    value="1"
                    :checked="productForm.isdeliverable"
                    @toggleChange="productForm.isdeliverable = $event"></f7-toggle>
            </f7-list-item>
            <f7-list-input
                :disabled="productForm.isdeliverable == false"
                class="align-right"
                label="Ongkos Kirim"
                type="number"
                placeholder="Rp 0"
                :value="productForm.delivery_cost"
                @input="productForm.delivery_cost = $event.target.value"
            ></f7-list-input>
            <f7-list-item>
				<div class="item-title">Setuju dengan ketentuan RingSatu</div>
				<f7-toggle 
					color="blue"
					:value="1"
					:checked="productForm.tac"
					@toggleChange="handleAgreed($event)"></f7-toggle>
			</f7-list-item>
        </f7-list>
        <p v-if="productForm.tac == true" style="text-align: justify;">Dengan ini saya setuju untuk tidak menjual barang/jasa yang melanggar undang-undang. Jika terjadi pelanggaran pada barang/jasa yang saya jual, RingSatu berhak untuk menghapus barang/jasa yang saya jual tanpa pemberitahuan.</p>
		<br>
		<f7-row>
			<f7-col>
				<f7-button @click="doSubmit($event, 'draft')" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button text-align-left" large>Simpan</f7-button>
			</f7-col>
			<f7-col>
				<f7-button @click="doSubmit($event, 'publish')" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left" large>Publikasikan</f7-button>
			</f7-col>
		</f7-row>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { parseError, dateFormat } from '../js/utils';
import { setTimeout } from 'timers';
import { parse } from 'path';
export default {
	name: 'ProductForm',
	data(){
		return{
            formType: 'Tambah',
			status: [{
				value: 'draft',
				label: 'Simpan'
			}, {
				value: 'publish',
				label: 'Publikasikan'
			}],
			productForm: {
                id: null,
                condition: 'new',
				title: '',
                description: '',
                minorder: 1,
                price: 0,
                discount: 0,
                isnegotiable: false,
                isdeliverable: false,
                delivery_cost: 0,
                category: null,
                unit: null,
				status: 'draft',
                medias: [],
                tac: false
            },
            medias: []
		}
	},
	computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('unit', ['units']),
		...mapGetters('category', [
            'marketplaceCategories',
            'pagination'
        ]),
		...mapGetters('product', [
			'product'
        ]),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
	},
	methods: {
		dateFormat,
		getCategories(){
			const self = this;
			const app = self.$f7;

			self.$store.dispatch('category/getCategories', {
				module: 'marketplace',
				perpage: 100,
				only: 'id,name,slug,childs'
			});
        },
        getUnits(){
			const self = this;
			const app = self.$f7;

			self.$store.dispatch('unit/getUnits', {
				perpage: 100,
				only: 'id,name,slug,symbol'
			});
		},
		onPageBeforeIn(page){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);

			if(self.$f7route.params && self.$f7route.params.id){
				self.formType = 'Ubah';
				self.productForm.id = self.$f7route.params.id;
			
				app.preloader.show('green');

				self.$store.dispatch('product/viewProduct', {
                    id: self.productForm.id,
                    only: 'id,conditions,title,slug,description,minorder,price,delivery_cost,discount,isdeliverable,isnegotiable,category.id,category.name,category.slug,created,updated,unit.id,unit.name,unit.symbol,author.id,author.profile.fullname,author.profile.store_name,author.profile.store_about,medias'
				}).then((response) => {
					self.productForm.condition = self.product.conditions;
					self.productForm.title = self.product.title;
					self.productForm.description = self.product.description;
                    self.productForm.category = self.product.category.id.toString();
                    self.productForm.minorder = self.product.minorder;
                    self.productForm.price = self.product.price;
                    self.productForm.discount = self.product.discount;
                    self.productForm.isnegotiable = self.product.isnegotiable;
                    self.productForm.isdeliverable = self.product.isdeliverable;
                    self.productForm.delivery_cost = self.product.delivery_cost;
                    self.productForm.unit = self.product.unit.id;
                    self.productForm.status = self.product.status;

					// if(self.product.medias != null){
					// 	self.productForm.medias = self.product.medias;
					// }

                    $el.find('select[name="category"]').find('option[value="'+self.product.category.id+'"]').prop('selected', true).trigger('change'); 
                    
                    $el.find('select[name="unit"]').find('option[value="'+self.product.unit.id+'"]').prop('selected', true).trigger('change'); 

					app.preloader.hide();
				});
            }

            self.getCategories();
            self.getUnits();
		},
		onPageBeforeOut(page){
            const self = this;
            
			if(page.detail.name == 'productform'){
				self.productForm = {
                    id: null,
                    condition: 'new',
                    title: '',
                    description: '',
                    minorder: 1,
                    price: 0,
                    discount: 0,
                    isnegotiable: false,
                    isdeliverable: false,
                    delivery_cost: 0,
                    category: null,
                    unit: null,
                    status: 'draft',                    
                    medias: []
                }
                
                self.medias = [];
                self.formType = 'Tambah';
			}
		},
		doSubmit(e, status){
			const self = this;
			const app = self.$f7;

            if(self.formType != 'Ubah' && self.productForm.medias.length == 0){
                app.dialog.alert('Silahkan unggah foto barang/jasa', 'RingSatu');
				return false;
			}else if(self.productForm.title.trim().length == 0){
				app.dialog.alert('Judul aduan wajib diisi', 'RingSatu');
				return false;
			}else if(/^([a-zA-Z0-9-()&\s/+.,?]{1,255})$/.test(self.productForm.title) == false){
				app.dialog.alert('Judul aduan hanya boleh diisi dengan dengan huruf, angka, tanda minus, tanda kurung tanda plus, garis miring, titik, koma dan spasi.', 'RingSatu');
				return false;
			}else if(self.productForm.description.trim().length == 0){
				app.dialog.alert('Judul barang/jasa wajib diisi', 'RingSatu');
				return false;
			}else if(self.productForm.category == null){
				app.dialog.alert('Kategori aduan wajib diisi', 'RingSatu');
                return false;
                
            }else if(parseInt(self.productForm.minorder) == 0){
				app.dialog.alert('Minimum order wajib diisi', 'RingSatu');
                return false;
                
            }else if(parseInt(self.productForm.price) == 0){
				app.dialog.alert('Harga wajib diisi', 'RingSatu');
                return false;

            }else if(parseInt(self.productForm.unit) == null){
				app.dialog.alert('Satuan wajib diisi', 'RingSatu');
                return false;
                
			}else if(parseInt(self.productForm.discount) > 100){
				app.dialog.alert('Diskon tidak boleh melebihi 100', 'RingSatu');
				return false;
			}else if(self.productForm.tac == false){
                app.dialog.alert('Anda harus setuju dengan syarat dan ketentuan RingSatu', 'RingSatu');
				return false;
            }

			app.preloader.show('green');

			let action = '';
			let params = {};

			if(self.formType == 'Ubah'){
				params.id = self.$f7route.params.id;
				action = 'product/editProduct';
			}else{
				action = 'product/createProduct';
			}

            params.condition = self.productForm.condition;
			params.title = self.productForm.title;
			params.description = self.productForm.description;
			params.category = parseInt(self.productForm.category);
			params.minorder = self.productForm.minorder;
			params.price = self.productForm.price;
            params.discount = self.productForm.discount;
            params.isnegotiable = self.productForm.isnegotiable;
            params.isdeliverable = self.productForm.isdeliverable;
            params.delivery_cost = self.productForm.delivery_cost;            
            params.unit = self.productForm.unit;
            params.medias = self.productForm.medias;
            
            params.status = status;
            
            if(self.user.profile.latitude != null && self.user.profile.longitude != null){
                params.latitude = self.user.profile.latitude;
                params.longitude = self.user.profile.longitude;
            }else{
                params.latitude = self.currentLocation.latitude;
                params.longitude = self.currentLocation.longitude;
            }

			self.$store.dispatch(action, params).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.$f7router.back({
						ignoreCache: true
					});
				}
			});
        },
        handleAgreed(value){
            const self = this;
            self.productForm.tac = value;
        },
		handleMediaDelete(e, imageId){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;

			app.dialog.confirm('Anda akan menghapus media ini. File tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Hapus File', function(){
				app.preloader.show('green');

				if(self.formType == 'Ubah'){
                    self.$store.dispatch('media/deleteMedia', {
                        id: parseInt(imageId),
                        endpoint: 'product'
                    }).then((response) => {
                        $$('#image-'+imageId).remove();
                        app.preloader.hide();
                    });
                }else{
                    self.$store.dispatch('media/deleteTmpMedia', {
                        id: parseInt(imageId),
                    }).then((response) => {
                        $$('#image-'+imageId).remove();
                        app.preloader.hide();
                    });
                }
			})
        },
        handleUpload(){

            const self = this;
            const app = self.$f7;
            const $$ = self.$$;
            const $el = self.$el;

            var ac = app.actions.create({
                buttons: [
                    {
                        text: 'Kamera', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.CAMERA)
                                .then(function (bannerImagePath) {
                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/product/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                        .then(function (r) {
                                            var response = JSON.parse(r.response);
                                            
                                            if(self.formType == 'Ubah'){
                                                self.product.medias.push(response.data.media);
                                            }else{
                                                self.productForm.medias.push(response.data.media.id);
                                                self.medias.push(response.data.media);
                                            }
                                            app.preloader.hide();
                                        })
                                        .catch(function (e) {
                                            app.preloader.hide();
                                        });
                                });
                        }
                    },
                    {
                        text: 'Galeri', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.PHOTOLIBRARY)
                                .then(function (bannerImagePath) {
                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/product/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                    .then(function (r) {
                                        var response = JSON.parse(r.response);

                                        if(self.formType == 'Ubah'){
                                            self.product.medias.push(response.data.media);
                                        }else{
                                            self.productForm.medias.push(response.data.media.id);
                                            self.medias.push(response.data.media);
                                        }

                                        app.preloader.hide();
                                    })
                                    .catch(function (e) {
                                        app.preloader.hide();
                                    });

                                });
                        }
                    },
                    {
                        text: 'Batal', color: 'red'
                    }
                ]
            });

            ac.open();
        }
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;
        const $el = self.$el;
    }
}
</script>
